Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Select_Reactor_Notify Class Reference

Unblock the <ACE_Select_Reactor> from its event loop. More...

`#include <Select_Reactor_Base.h>`

Inheritance diagram for ACE_Select_Reactor_Notify:

[legend]
Collaboration diagram for ACE_Select_Reactor_Notify:

[legend]
List of all members.

## Public Methods
| ACE_Select_Reactor_Notify (void)
| Constructor. More...
| ~ACE_Select_Reactor_Notify (void)
| Destructor. More...
virtual int | open (ACE_Reactor_Impl *, ACE_Timer_Queue *=0, int disable_notify_pipe=0)
| Initialize. More...
virtual int | close (void)
| Destroy. More...
virtual int | notify (ACE_Event_Handler *=0, ACE_Reactor_Mask=ACE_Event_Handler::EXCEPT_MASK, ACE_Time_Value *=0)
virtual int | dispatch_notifications (int &number_of_active_handles, ACE_Handle_Set &rd_mask)
| Handles pending threads (if any) that are waiting to unblock the <ACE_Select_Reactor>. More...
virtual ACE_HANDLE | notify_handle (void)
| Returns the ACE_HANDLE of the notify pipe on which the reactor is listening for notifications so that other threads can unblock the Select_Reactor. More...
virtual int | dispatch_notify (ACE_Notification_Buffer &buffer)
| Handle one of the notify call on the <handle>. This could be because of a thread trying to unblock the <Reactor_Impl>. More...
virtual int | read_notify_pipe (ACE_HANDLE handle, ACE_Notification_Buffer &buffer)
| Read one of the notify call on the <handle> into the <buffer>. This could be because of a thread trying to unblock the <Reactor_Impl>. More...
virtual int | is_dispatchable (ACE_Notification_Buffer &buffer)
| Verify whether the buffer has dispatchable info or not. More...
virtual int | handle_input (ACE_HANDLE handle)
| Called back by the <ACE_Select_Reactor> when a thread wants to unblock us. More...
virtual void | max_notify_iterations (int)
virtual int | max_notify_iterations (void)
virtual int | purge_pending_notifications (ACE_Event_Handler *, ACE_Reactor_Mask=ACE_Event_Handler::ALL_EVENTS_MASK)
virtual void | dump (void) const
| Dump the state of an object. More...
## Public Attributes
| ACE_ALLOC_HOOK_DECLARE
| Declare the dynamic allocation hooks. More...
## Protected Attributes
ACE_Select_Reactor_Impl * | select_reactor_
ACE_Pipe | notification_pipe_
int | max_notify_iterations_

## Detailed Description

Unblock the <ACE_Select_Reactor> from its event loop.

This implementation is necessary for cases where the <ACE_Select_Reactor> is run in a multi-threaded program. In this case, we need to be able to unblock <select> or <poll> when updates occur other than in the main <ACE_Select_Reactor> thread. To do this, we signal an auto-reset event the <ACE_Select_Reactor> is listening on. If an <ACE_Event_Handler> and <ACE_Select_Reactor_Mask> is passed to <notify>, the appropriate <handle_*> method is dispatched in the context of the <ACE_Select_Reactor> thread.

## Constructor & Destructor Documentation

ACE_Select_Reactor_Notify::ACE_Select_Reactor_Notify | ( | void |  | ) |

| Constructor.

ACE_INLINE ACE_Select_Reactor_Notify::~ACE_Select_Reactor_Notify | ( | void |  | ) |

| Destructor.

## Member Function Documentation

int ACE_Select_Reactor_Notify::close | ( | void |  | ) | `[virtual]`

| Destroy. Reimplemented from ACE_Reactor_Notify.

int ACE_Select_Reactor_Notify::dispatch_notifications | ( | int & | number_of_active_handles,
|  | ACE_Handle_Set & | rd_mask
| ) | `[virtual]`

| Handles pending threads (if any) that are waiting to unblock the <ACE_Select_Reactor>. Reimplemented from ACE_Reactor_Notify.

int ACE_Select_Reactor_Notify::dispatch_notify | ( | ACE_Notification_Buffer & | buffer | ) | `[virtual]`

| Handle one of the notify call on the <handle>. This could be because of a thread trying to unblock the <Reactor_Impl>. Reimplemented from ACE_Reactor_Notify.

void ACE_Select_Reactor_Notify::dump | ( | void |  | ) | const`[virtual]`

| Dump the state of an object. Reimplemented from ACE_Reactor_Notify.

int ACE_Select_Reactor_Notify::handle_input | ( | ACE_HANDLE | handle | ) | `[virtual]`

| Called back by the <ACE_Select_Reactor> when a thread wants to unblock us. Reimplemented from ACE_Event_Handler.

int ACE_Select_Reactor_Notify::is_dispatchable | ( | ACE_Notification_Buffer & | buffer | ) | `[virtual]`

| Verify whether the buffer has dispatchable info or not. Reimplemented from ACE_Reactor_Notify.

int ACE_Select_Reactor_Notify::max_notify_iterations | ( | void |  | ) | `[virtual]`

| Get the maximum number of times that the <ACE_Select_Reactor_Notify::handle_input> method will iterate and dispatch the <ACE_Event_Handlers> that are passed in via the notify pipe before breaking out of its <recv> loop. Reimplemented from ACE_Reactor_Notify.

void ACE_Select_Reactor_Notify::max_notify_iterations | ( | int | iterations | ) | `[virtual]`

| Set the maximum number of times that the <ACE_Select_Reactor_Notify::handle_input> method will iterate and dispatch the <ACE_Event_Handlers> that are passed in via the notify pipe before breaking out of its <recv> loop. By default, this is set to -1, which means "iterate until the pipe is empty." Setting this to a value like "1 or 2" will increase "fairness" (and thus prevent starvation) at the expense of slightly higher dispatching overhead. Reimplemented from ACE_Reactor_Notify.

int ACE_Select_Reactor_Notify::notify | ( | ACE_Event_Handler * | eh = 0,
|  | ACE_Reactor_Mask | mask = ACE_Event_Handler::EXCEPT_MASK,
|  | ACE_Time_Value * | timeout = 0
| ) | `[virtual]`

| Called by a thread when it wants to unblock the <ACE_Select_Reactor>. This wakeups the <ACE_Select_Reactor> if currently blocked in <select>/<poll>. Pass over both the <Event_Handler> *and* the <mask> to allow the caller to dictate which <Event_Handler> method the <ACE_Select_Reactor> will invoke. The <ACE_Time_Value> indicates how long to blocking trying to notify the <ACE_Select_Reactor>. If <timeout> == 0, the caller will block until action is possible, else will wait until the relative time specified in *<timeout> elapses). Reimplemented from ACE_Reactor_Notify.

ACE_HANDLE ACE_Select_Reactor_Notify::notify_handle | ( | void |  | ) | `[virtual]`

| Returns the ACE_HANDLE of the notify pipe on which the reactor is listening for notifications so that other threads can unblock the Select_Reactor. Reimplemented from ACE_Reactor_Notify.

int ACE_Select_Reactor_Notify::open | ( | ACE_Reactor_Impl * | r,
|  | ACE_Timer_Queue * | timer_queue = 0,
|  | int | disable_notify_pipe = 0
| ) | `[virtual]`

| Initialize. Reimplemented from ACE_Reactor_Notify.

int ACE_Select_Reactor_Notify::purge_pending_notifications | ( | ACE_Event_Handler * | eh,
|  | ACE_Reactor_Mask | mask = ACE_Event_Handler::ALL_EVENTS_MASK
| ) | `[virtual]`

| Purge any notifications pending in this reactor for the specified <ACE_Event_Handler> object. If <eh> == 0, all notifications for all handlers are removed (but not any notifications posted just to wake up the reactor itself). Returns the number of notifications purged. Returns -1 on error. Reimplemented from ACE_Reactor_Notify.

int ACE_Select_Reactor_Notify::read_notify_pipe | ( | ACE_HANDLE | handle,
|  | ACE_Notification_Buffer & | buffer
| ) | `[virtual]`

| Read one of the notify call on the <handle> into the <buffer>. This could be because of a thread trying to unblock the <Reactor_Impl>. Reimplemented from ACE_Reactor_Notify.

## Member Data Documentation

ACE_Select_Reactor_Notify::ACE_ALLOC_HOOK_DECLARE

| Declare the dynamic allocation hooks.

int ACE_Select_Reactor_Notify::max_notify_iterations_`[protected]`

| Keeps track of the maximum number of times that the <ACE_Select_Reactor_Notify::handle_input> method will iterate and dispatch the <ACE_Event_Handlers> that are passed in via the notify pipe before breaking out of its <recv> loop. By default, this is set to -1, which means "iterate until the pipe is empty."

ACE_Pipe ACE_Select_Reactor_Notify::notification_pipe_`[protected]`

| Contains the <ACE_HANDLE> the <ACE_Select_Reactor> is listening on, as well as the <ACE_HANDLE> that threads wanting the attention of the <ACE_Select_Reactor> will write to.

ACE_Select_Reactor_Impl* ACE_Select_Reactor_Notify::select_reactor_`[protected]`

| Keep a back pointer to the <ACE_Select_Reactor>. If this value if NULL then the <ACE_Select_Reactor> has been initialized with <disable_notify_pipe>.

The documentation for this class was generated from the following files:

- Select_Reactor_Base.h
- Select_Reactor_Base.cpp
- Select_Reactor_Base.i